precision mediump float;
//heat, saturation

varying lowp vec4 vColor; //#saturation:0..2
varying vec2 vTexCoord;
uniform sampler2D u_texture;

//const mediump vec3 W = vec3(0.3, 0.59, 0.11);
const mediump vec3 W = vec3(0.2125, 0.7154, 0.0721);
const mediump vec3 h = vec3(0.3, 0.59, 0.11);

 void main()
 {
     lowp vec4 textureColor = texture2D(u_texture, vTexCoord);
     vec3 vColor2 = vec3(0.0);
     vColor2.r = vColor.r+0.5;
     vColor2.g = vColor.g+0.5;
     vColor2.b = vColor.b+0.5;
     highp vec3 Wcolored = vec3(W.r*vColor2.r,W.g*vColor2.g,W.b*vColor2.b);

     lowp float lum = dot(textureColor.rgb, Wcolored);


     highp vec3 colored = vec3(vColor2.r*textureColor.r,vColor2.g*textureColor.g,vColor2.b*textureColor.b);

     lowp vec3 newColor = mix(vec3(lum), colored, 1.);

     lowp float lumSat = dot(newColor.rgb, h);
     lowp vec3 newColorSat = mix(vec3(lumSat), newColor.rgb, vColor.a*2.);

gl_FragColor = vec4(newColorSat,1.);

 }