precision mediump float;
varying lowp vec4 vColor; /*Exposure (-1  1)
                            Shadows 0   1.0  //0 0.5
                            Highlights   0   1
                            Constrast  -1   1*/
varying vec2 vTexCoord;
uniform sampler2D u_texture;

#define STRETCH(x,a,b) min(1.0,max(0.0,((x)-(a))/((b)-(a))))
const mediump vec3 average = vec3(0.5, 0.5, 0.5);

void main() {
float gamma = pow(10.0, -(vColor.a*2. -1.));
float value = vColor.b*2. -1.;
float contrast =(value > 0.0)? (1.0+value+10.0*pow(value, 4.5)) : (1.0+value);
float shadows = vColor.r;
float highlights = 1.0-0.5*vColor.g;

vec4 texColor = texture2D(u_texture, vTexCoord);

     texColor.r = STRETCH(texColor.r,shadows,highlights);
     texColor.g = STRETCH(texColor.g,shadows,highlights);
     texColor.b = STRETCH(texColor.b,shadows,highlights);

     texColor.r = pow(texColor.r,gamma);
     texColor.g = pow(texColor.g,gamma);
     texColor.b = pow(texColor.b,gamma);


gl_FragColor = vec4((texColor.rgb-average)*contrast+average, 1.);
}