attribute highp vec4 a_position;
attribute highp vec4 a_color;
attribute highp vec2 a_texCoord0;
uniform highp mat4 u_projTrans;
varying highp vec4 vColor;
varying highp vec2 vTexCoord;

 varying vec2 v_LeftTexCoordinate;
 varying vec2 v_RightTexCoordinate;
 varying vec2 v_TopTexCoordinate;
 varying vec2 v_BottomTexCoordinate;

 varying float v_CenterMultiplier;
 varying float v_EdgeMultiplier;

void main() {
vColor = a_color; //z = uSharp 0..1,  x,y = 1/imageW, 1/imageH
float u_Sharpness =a_color.a;

vTexCoord = a_texCoord0;


     vec2 widthStep = vec2(vColor.r, 0.0);
     vec2 heightStep = vec2(0.0, vColor.g);


     v_LeftTexCoordinate = a_texCoord0.xy - widthStep;
     v_RightTexCoordinate = a_texCoord0.xy + widthStep;
     v_TopTexCoordinate = a_texCoord0.xy + heightStep;
     v_BottomTexCoordinate = a_texCoord0.xy - heightStep;

     v_CenterMultiplier = 1.0 + 4.0 * u_Sharpness;
     v_EdgeMultiplier = u_Sharpness;

     gl_Position =  u_projTrans * a_position;
}