precision lowp float;
 
 varying highp vec2 vTexCoord;
 
 uniform sampler2D u_texture;
 
 uniform highp vec3 u_Color;
 uniform highp vec3 u_Color2;
 uniform float u_Brightness;
 uniform float u_Contrast;

 const mediump vec3 W = vec3(0.299, 0.587, 0.114);
 
 void main() {  
     lowp vec4 textureColor = texture2D(u_texture, vTexCoord);
     
     float lum = dot(textureColor.rgb, W);
     
     lowp vec3 rgb = mix(u_Color, u_Color2, lum);
     
     rgb = rgb*u_Brightness*u_Contrast + 0.5*u_Brightness*(1.0-u_Contrast);
     gl_FragColor = vec4(rgb, textureColor.a);
    
 }