precision mediump float;
 varying lowp vec4 vColor;
 varying vec2 vTexCoord;
 uniform sampler2D u_texture;
 uniform sampler2D paint_texture;
 uniform sampler2D overlay_texture;
     const mediump vec3 W = vec3(0.299, 0.587, 0.114);
     uniform vec4 u_Color;
     uniform vec4 u_Color2;
     uniform float u_Brightness;
     uniform float u_Contrast;
 void main() {
 vec4 base = texture2D(u_texture, vTexCoord);
      float lum = dot(base.rgb, W);
      lowp vec3 rgb = mix(u_Color.rgb, u_Color2.rgb, lum);
      rgb = rgb*u_Brightness*u_Contrast + 0.5*u_Brightness*(1.0-u_Contrast);
      vec4 overlay = vec4(rgb, base.a);

 overlay *= vColor.a;
     
     lowp vec4 fc;
     
     fc.r = overlay.r <= 0.5 ? 2.0*overlay.r*base.r + overlay.r*(1.0-base.a)+base.r*(1.0-overlay.a) : 2.0*(base.r+overlay.r - base.r*overlay.r) - 1.0*(overlay.a);
     fc.g = overlay.g <= 0.5 ? 2.0*overlay.g*base.g + overlay.g*(1.0-base.a)+base.g*(1.0-overlay.a) : 2.0*(base.g+overlay.g - base.g*overlay.g) - 1.0*(overlay.a);
     fc.b = overlay.b <= 0.5 ? 2.0*overlay.b*base.b + overlay.b*(1.0-base.a)+base.b*(1.0-overlay.a) : 2.0*(base.b+overlay.b - base.b*overlay.b) - 1.0*(overlay.a);
     
     fc.a = overlay.a + base.a - overlay.a*base.a;
     
     fc.rgb = (base.a == 0.0) ? overlay.rgb : fc.rgb;
     
     
     gl_FragColor = fc;
 }