precision mediump float;
 varying lowp vec4 vColor;
 varying vec2 vTexCoord;
 uniform sampler2D u_texture;
 uniform sampler2D paint_texture;
 uniform sampler2D overlay_texture;
     const mediump vec3 W = vec3(0.299, 0.587, 0.114);
     uniform vec4 u_Color;
     uniform vec4 u_Color2;
     uniform float u_Brightness;
     uniform float u_Contrast;
 
 #define OVERLAY(b,o) (((b)<=0.5)?(2.0*(b)*(o)):((o)+((2.0*(b))-1.0)*(1.0-(o))))
  
 const lowp vec4 mid = vec4(vec3(0.5),1.0);
 void main() {
 vec4 base = texture2D(u_texture, vTexCoord);
      float lum = dot(base.rgb, W);
      lowp vec3 rgb = mix(u_Color.rgb, u_Color2.rgb, lum);
      rgb = rgb*u_Brightness*u_Contrast + 0.5*u_Brightness*(1.0-u_Contrast);
      vec4 overlay = vec4(rgb, base.a);

lowp vec4 c2 = mid;
    lowp vec4 oc;
    lowp float pa = c2.a * (1.0 - overlay.a);
     
     oc.r = overlay.r + c2.r * pa;
     oc.g = overlay.g + c2.g * pa;
     oc.b = overlay.b + c2.b * pa;
     oc.a = overlay.a + pa;
     
     lowp vec3 blend = vec3(OVERLAY(base.r,oc.r),OVERLAY(base.g,oc.g),OVERLAY(base.b,oc.b));
     
     gl_FragColor = vec4(mix(base.rgb,blend,vColor.a), base.a);
 }