precision mediump float;
 varying lowp vec4 vColor;
 varying vec2 vTexCoord;
 uniform sampler2D u_texture;
 uniform sampler2D paint_texture;
 uniform sampler2D overlay_texture;
    const mediump vec3 W = vec3(0.299, 0.587, 0.114);
    uniform vec4 u_Color;
    uniform vec4 u_Color2;
    uniform float u_Brightness;
    uniform float u_Contrast;
 void main() {
 vec4 base = texture2D(u_texture, vTexCoord);
      float lum = dot(base.rgb, W);
      lowp vec3 rgb = mix(u_Color.rgb, u_Color2.rgb, lum);
      rgb = rgb*u_Brightness*u_Contrast + 0.5*u_Brightness*(1.0-u_Contrast);
      vec4 overlay = vec4(rgb, base.a);

   overlay.rgb = overlay.rgb*overlay.a;
     
    lowp vec4 blend = base * (overlay.a * (base / base.a) + (2.0 * overlay * (1.0 - (base / base.a)))) + overlay * (1.0 - base.a) + base * (1.0 - overlay.a);
     
    gl_FragColor = vec4(mix(base.rgb,blend.rgb,vColor.a), base.a);
 }