 varying highp vec2 v_TexCoordinate;
 #define OVERLAY(b,o) (((b)<=0.5)?(2.0*(b)*(o)):((o)+((2.0*(b))-1.0)*(1.0-(o))))
 uniform sampler2D u_Texture;
 
 uniform lowp vec4 u_Color;
 uniform lowp vec4 u_Color2;
 uniform lowp float u_Ratio;
 uniform highp float u_AspectRatio;
 uniform highp float u_Angle;//radians
 
 uniform highp int u_GradType;
 uniform highp float u_Fade;
 uniform highp vec2 u_RightBottom;
 
 const lowp vec2 c_Center = vec2(0.5);
 const lowp vec4 mid = vec4(vec3(0.5),1.0);
 
 void main()
 {
	 lowp vec4 base = texture2D(u_Texture, v_TexCoordinate);
     
     lowp vec2 coords = v_TexCoordinate;
     
     highp float quotient = 1.0;
     
     coords.x = coords.x / u_RightBottom.x;
     coords.y = coords.y / u_RightBottom.y;
     
     if(u_GradType==2){
         
         coords.x = 1.0-2.0*(abs((coords.x-c_Center.x)*cos(u_Angle)+(coords.y-c_Center.y)*sin(u_Angle)));//mirror
         
     } else if(u_GradType==1){
         
         lowp vec2 center = c_Center;//vec2(c_Center);
         
         coords.x = u_AspectRatio*coords.x; 
         center.x = u_AspectRatio*center.x;
         
         highp float D = sqrt(1.0+u_AspectRatio*u_AspectRatio);
         
         coords.x = coords.x/D;
         coords.y = coords.y/D;
         center.x = center.x/D;
         center.y = center.y/D;
         
         coords.x = distance(center,coords)*2.0;//radial
         
     } else{ 
         coords.x = (coords.x-c_Center.x)*cos(u_Angle)+(coords.y-c_Center.y)*sin(u_Angle)+c_Center.x;//linear 
         
     }  
     
     if(u_Ratio > 0.0){
         coords.x = coords.x > 1.0-u_Ratio ? 1.0 : (coords.x)/(1.0-u_Ratio);
     } else if(u_Ratio < 0.0) coords.x = coords.x < -u_Ratio ? 0.0 : (coords.x+u_Ratio)/(1.0+u_Ratio);
     
     quotient = coords.x;
     lowp vec4 c1 = mix(u_Color,u_Color2,quotient);
     
     c1.rgb = c1.rgb*c1.a;//need for not black transparent colors, strange in simple texture transparent that is not need
     
     lowp vec4 c2 = mid;
     lowp vec4 oc;
     lowp float pa = c2.a * (1.0 - c1.a);
     
     oc.r = c1.r + c2.r * pa;
     oc.g = c1.g + c2.g * pa;
     oc.b = c1.b + c2.b * pa;
     oc.a = c1.a + pa;
     
     lowp vec3 blend = vec3(OVERLAY(base.r,oc.r),OVERLAY(base.g,oc.g),OVERLAY(base.b,oc.b));
     
     gl_FragColor = vec4(mix(base.rgb,blend,u_Fade), base.a);
 
 
 }