precision lowp float;
 
varying highp vec2 v_TexCoordinate;
varying highp vec2 v_TexCoordinate2;
 
uniform sampler2D u_Texture;
uniform sampler2D u_Texture2;
uniform highp float u_Fade;
 


void main() {  
	lowp vec4 base = texture2D(u_Texture, v_TexCoordinate);
	lowp vec4 overlay = texture2D(u_Texture2,v_TexCoordinate2);
    overlay *= u_Fade;
     
     lowp vec4 fc;
     
     fc.r = overlay.r <= 0.5 ? 2.0*overlay.r*base.r + overlay.r*(1.0-base.a)+base.r*(1.0-overlay.a) : 2.0*(base.r+overlay.r - base.r*overlay.r) - 1.0*(overlay.a);
     fc.g = overlay.g <= 0.5 ? 2.0*overlay.g*base.g + overlay.g*(1.0-base.a)+base.g*(1.0-overlay.a) : 2.0*(base.g+overlay.g - base.g*overlay.g) - 1.0*(overlay.a);
     fc.b = overlay.b <= 0.5 ? 2.0*overlay.b*base.b + overlay.b*(1.0-base.a)+base.b*(1.0-overlay.a) : 2.0*(base.b+overlay.b - base.b*overlay.b) - 1.0*(overlay.a);
     
     fc.a = overlay.a + base.a - overlay.a*base.a;
     
     fc.rgb = (base.a == 0.0) ? overlay.rgb : fc.rgb;
     
     
     gl_FragColor = fc;
}