precision lowp float;
 
varying highp vec2 v_TexCoordinate;
varying highp vec2 v_TexCoordinate2;
 
uniform sampler2D u_Texture;
uniform sampler2D u_Texture2;
uniform highp float u_Fade;
#define OVERLAY(b,o) (((b)<=0.5)?(2.0*(b)*(o)):((o)+((2.0*(b))-1.0)*(1.0-(o))))
 
const lowp vec4 mid = vec4(vec3(0.5),1.0);
 
void main() {  
	lowp vec4 base = texture2D(u_Texture, v_TexCoordinate);
	lowp vec4 overlay = texture2D(u_Texture2,v_TexCoordinate2);
	lowp vec4 c2 = mid;
    lowp vec4 oc;
    lowp float pa = c2.a * (1.0 - overlay.a);
     
     oc.r = overlay.r + c2.r * pa;
     oc.g = overlay.g + c2.g * pa;
     oc.b = overlay.b + c2.b * pa;
     oc.a = overlay.a + pa;
     
     lowp vec3 blend = vec3(OVERLAY(base.r,oc.r),OVERLAY(base.g,oc.g),OVERLAY(base.b,oc.b));
     
     gl_FragColor = vec4(mix(base.rgb,blend,u_Fade), base.a);
}