precision lowp float;
 
varying highp vec2 v_TexCoordinate;
varying highp vec2 v_TexCoordinate2;
 
uniform sampler2D u_Texture;
uniform sampler2D u_Texture2;
uniform highp float u_Fade;
 
#define SOFTLIGHT(b,t) (((b)<0.5)?(((t)+0.5)*b):(1.0-2.0*(0.75-(t)*0.5)*(1.0-(b))))
 
void main() {  
	lowp vec4 base = texture2D(u_Texture, v_TexCoordinate);
	lowp vec4 overlay = texture2D(u_Texture2,v_TexCoordinate2);
     
    overlay.rgb = overlay.rgb*overlay.a;
     
    lowp vec4 blend = base * (overlay.a * (base / base.a) + (2.0 * overlay * (1.0 - (base / base.a)))) + overlay * (1.0 - base.a) + base * (1.0 - overlay.a);
     
    gl_FragColor = vec4(mix(base.rgb,blend.rgb,u_Fade), base.a);
}