precision mediump float;
 varying lowp vec4 vColor;
 varying vec2 vTexCoord;
 uniform sampler2D u_texture;
 uniform sampler2D paint_texture;
 uniform sampler2D overlay_texture;
  uniform lowp vec4 u_Distortion;
 void main() {
 vec4 base = texture2D(u_texture, vTexCoord);
vec2 distCoords = vec2((vTexCoord.x-u_Distortion.x)/u_Distortion.z+0.5,(vTexCoord.y - u_Distortion.y)/u_Distortion.w+0.5);
vec4 overlay = texture2D(overlay_texture, distCoords);

 overlay *= vColor.a;
     
     lowp vec4 fc;
     
     fc.r = overlay.r <= 0.5 ? 2.0*overlay.r*base.r + overlay.r*(1.0-base.a)+base.r*(1.0-overlay.a) : 2.0*(base.r+overlay.r - base.r*overlay.r) - 1.0*(overlay.a);
     fc.g = overlay.g <= 0.5 ? 2.0*overlay.g*base.g + overlay.g*(1.0-base.a)+base.g*(1.0-overlay.a) : 2.0*(base.g+overlay.g - base.g*overlay.g) - 1.0*(overlay.a);
     fc.b = overlay.b <= 0.5 ? 2.0*overlay.b*base.b + overlay.b*(1.0-base.a)+base.b*(1.0-overlay.a) : 2.0*(base.b+overlay.b - base.b*overlay.b) - 1.0*(overlay.a);
     
     fc.a = overlay.a + base.a - overlay.a*base.a;
     
     fc.rgb = (base.a == 0.0) ? overlay.rgb : fc.rgb;
     
     
     gl_FragColor = fc;
 }