precision mediump float;
 varying lowp vec4 vColor;
 varying vec2 vTexCoord;
 uniform sampler2D u_texture;
 uniform sampler2D paint_texture;
 uniform sampler2D overlay_texture;
  uniform lowp vec4 u_Distortion;
 
 #define OVERLAY(b,o) (((b)<=0.5)?(2.0*(b)*(o)):((o)+((2.0*(b))-1.0)*(1.0-(o))))
  
 const lowp vec4 mid = vec4(vec3(0.5),1.0);
 void main() {
 vec4 base = texture2D(u_texture, vTexCoord);
vec2 distCoords = vec2((vTexCoord.x-u_Distortion.x)/u_Distortion.z+0.5,(vTexCoord.y - u_Distortion.y)/u_Distortion.w+0.5);
vec4 overlay = texture2D(overlay_texture, distCoords);
lowp vec4 c2 = mid;
    lowp vec4 oc;
    lowp float pa = c2.a * (1.0 - overlay.a);
     
     oc.r = overlay.r + c2.r * pa;
     oc.g = overlay.g + c2.g * pa;
     oc.b = overlay.b + c2.b * pa;
     oc.a = overlay.a + pa;
     
     lowp vec3 blend = vec3(OVERLAY(base.r,oc.r),OVERLAY(base.g,oc.g),OVERLAY(base.b,oc.b));
     
     gl_FragColor = vec4(mix(base.rgb,blend,vColor.a), base.a);
 }