precision mediump float;
 varying lowp vec4 vColor;
 varying vec2 vTexCoord;
 uniform sampler2D u_texture;
 uniform sampler2D paint_texture;
 uniform sampler2D overlay_texture;

 uniform mediump vec4 v_transform;
 uniform mediump vec3 v_axis_switch;

 #define OVERLAY(b,o) (((b)<=0.5)?(2.0*(b)*(o)):((o)+((2.0*(b))-1.0)*(1.0-(o))))

  const lowp vec4 mid = vec4(vec3(0.5),1.0);

 void main() {
 vec4 base = texture2D(u_texture, vTexCoord);
 vec4 mask = texture2D(paint_texture, vTexCoord);
 vec4 overlay;

 vec2 vTexCoordTransform;

  if (v_axis_switch.x==1.0)  {
  vTexCoordTransform.x = 1.0-vTexCoord.x;
  } else {
  vTexCoordTransform.x = vTexCoord.x;
  }


  if (v_axis_switch.y==1.0)  {
  vTexCoordTransform.y = 1.0-vTexCoord.y;
  }
  else {
  vTexCoordTransform.y = vTexCoord.y;
  }


float tmpAxis;
 if (v_axis_switch.z == 1.0) {
  tmpAxis = vTexCoordTransform.x;
 vTexCoordTransform.x = vTexCoordTransform.y;
 vTexCoordTransform.y = tmpAxis;
 }


 overlay = texture2D(overlay_texture, -v_transform.xy+(vTexCoordTransform)*v_transform.zw);

	//gl_FragColor = mask*mix(overlay,  base,vColor.a)+vec4(1.0-mask.rgb,1.0)*base;
	lowp float power = (1.0-mask.r)*vColor.a;
	//overlay = vec4(dot(overlay.rgb,mask.rgb),1.0);


lowp vec4 c2 = mid;
    lowp vec4 oc;
    lowp float pa = c2.a * (1.0 - overlay.a);

     oc.r = overlay.r + c2.r * pa;
     oc.g = overlay.g + c2.g * pa;
     oc.b = overlay.b + c2.b * pa;
     oc.a = overlay.a + pa;

     lowp vec3 blend = vec3(OVERLAY(base.r,oc.r),OVERLAY(base.g,oc.g),OVERLAY(base.b,oc.b));

     vec4 fc = vec4(mix(base.rgb,blend,vColor.a), base.a);


	gl_FragColor = mix(base,fc,power);
 }